package test.auth

import auth.User

describe User "User with name, login and password that supports authentication" {
	val user = new User("John Smith", "j.smith", "pass1")

	fact "User can be created with user name, login and password" => [
		user => [
			username => "John Smith"
			login => "j.smith"
		]
	]
	
	fact "User accepts correct login and password" => [
		user.login("j.smith", "pass1") => true
	]
	
	fact "User doesn't accept wrong login" => [
		user.login("j.doe", "pass1") => false
	]
	
	fact "User doesn't accept wrong password" => [
		user.login("j.smith", "pass2") => false
	]
	
	
}