package test.auth;

import org.hamcrest.StringDescription;
import org.jnario.lib.JnarioIterableExtensions;
import org.jnario.lib.Should;
import org.jnario.lib.StepArguments;
import org.jnario.runner.FeatureRunner;
import org.jnario.runner.Named;
import org.jnario.runner.Order;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import test.auth.UserLoginFeatureBackground;

@RunWith(FeatureRunner.class)
@Named("Scenario: Users with incorrect credentials can login")
@SuppressWarnings("all")
public class UserLoginFeatureUsersWithIncorrectCredentialsCanLogin extends UserLoginFeatureBackground {
  @Test
  @Order(0)
  @Named("Given a user with user name \"j.smith\" and password \"pass1\"")
  public void givenAUserWithUserNameJSmithAndPasswordPass1() {
    super.givenAUserWithUserNameJSmithAndPasswordPass1();
  }
  
  @Test
  @Order(1)
  @Named("When the user tries to login with a incorrect password \"pass2\"")
  public void whenTheUserTriesToLoginWithAIncorrectPasswordPass2() {
      StepArguments _stepArguments = new StepArguments("pass2");
      final StepArguments args = _stepArguments;
      String _login = this.user.getLogin();
      String _first = JnarioIterableExtensions.<String>first(args);
      boolean _login_1 = this.user.login(_login, _first);
      this.result = _login_1;
  }
  
  @Test
  @Order(2)
  @Named("Then it doesn\'t work")
  public void thenItDoesnTWork() {
    boolean _doubleArrow = Should.operator_doubleArrow(Boolean.valueOf(this.result), Boolean.valueOf(false));
    Assert.assertTrue("\nExpected result => false but"
     + "\n     result is " + new StringDescription().appendValue(Boolean.valueOf(this.result)).toString() + "\n", _doubleArrow);
    
  }
}
