package test.auth;

import auth.User;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.hamcrest.StringDescription;
import org.jnario.lib.Should;
import org.jnario.runner.ExampleGroupRunner;
import org.jnario.runner.Named;
import org.jnario.runner.Order;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;

@SuppressWarnings("all")
@RunWith(ExampleGroupRunner.class)
@Named("User User with name, login and password that supports authentication")
public class UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec {
  final User user = new Function0<User>() {
    public User apply() {
      User _user = new User("John Smith", "j.smith", "pass1");
      return _user;
    }
  }.apply();
  
  @Test
  @Named("\\\"User can be created with user name, login and password\\\" => [ user => [ username => \\\"John Smith\\\" login => \\\"j.smith\\\" ] ]")
  @Order(99)
  public void userCanBeCreatedWithUserNameLoginAndPasswordUserUsernameJohnSmithLoginJSmith() throws Exception {
    final Procedure1<String> _function = new Procedure1<String>() {
        public void apply(final String it) {
          final Procedure1<User> _function = new Procedure1<User>() {
              public void apply(final User it) {
                String _username = it.getUsername();
                boolean _doubleArrow = Should.operator_doubleArrow(_username, "John Smith");
                Assert.assertTrue("\nExpected username => \"John Smith\" but"
                 + "\n     username is " + new StringDescription().appendValue(_username).toString() + "\n", _doubleArrow);
                
                String _login = it.getLogin();
                boolean _doubleArrow_1 = Should.operator_doubleArrow(_login, "j.smith");
                Assert.assertTrue("\nExpected login => \"j.smith\" but"
                 + "\n     login is " + new StringDescription().appendValue(_login).toString() + "\n", _doubleArrow_1);
                
              }
            };
          ObjectExtensions.<User>operator_doubleArrow(
            UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec.this.user, _function);
        }
      };
    ObjectExtensions.<String>operator_doubleArrow("User can be created with user name, login and password", _function);
  }
  
  @Test
  @Named("\\\"User accepts correct login and password\\\" => [ user.login[\\\"j.smith\\\", \\\"pass1\\\"] => true ]")
  @Order(99)
  public void userAcceptsCorrectLoginAndPasswordUserLoginJSmithPass1True() throws Exception {
    final Procedure1<String> _function = new Procedure1<String>() {
        public void apply(final String it) {
          boolean _login = UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec.this.user.login("j.smith", "pass1");
          boolean _doubleArrow = Should.operator_doubleArrow(Boolean.valueOf(_login), Boolean.valueOf(true));
          Assert.assertTrue("\nExpected user.login(\"j.smith\", \"pass1\") => true but"
           + "\n     user.login(\"j.smith\", \"pass1\") is " + new StringDescription().appendValue(Boolean.valueOf(_login)).toString()
           + "\n     user is " + new StringDescription().appendValue(UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec.this.user).toString() + "\n", _doubleArrow);
          
        }
      };
    ObjectExtensions.<String>operator_doubleArrow("User accepts correct login and password", _function);
  }
  
  @Test
  @Named("\\\"User doesn\\\'t accept wrong login\\\" => [ user.login[\\\"j.doe\\\", \\\"pass1\\\"] => false ]")
  @Order(99)
  public void userDoesnTAcceptWrongLoginUserLoginJDoePass1False() throws Exception {
    final Procedure1<String> _function = new Procedure1<String>() {
        public void apply(final String it) {
          boolean _login = UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec.this.user.login("j.doe", "pass1");
          boolean _doubleArrow = Should.operator_doubleArrow(Boolean.valueOf(_login), Boolean.valueOf(false));
          Assert.assertTrue("\nExpected user.login(\"j.doe\", \"pass1\") => false but"
           + "\n     user.login(\"j.doe\", \"pass1\") is " + new StringDescription().appendValue(Boolean.valueOf(_login)).toString()
           + "\n     user is " + new StringDescription().appendValue(UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec.this.user).toString() + "\n", _doubleArrow);
          
        }
      };
    ObjectExtensions.<String>operator_doubleArrow("User doesn\'t accept wrong login", _function);
  }
  
  @Test
  @Named("\\\"User doesn\\\'t accept wrong password\\\" => [ user.login[\\\"j.smith\\\", \\\"pass2\\\"] => false ]")
  @Order(99)
  public void userDoesnTAcceptWrongPasswordUserLoginJSmithPass2False() throws Exception {
    final Procedure1<String> _function = new Procedure1<String>() {
        public void apply(final String it) {
          boolean _login = UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec.this.user.login("j.smith", "pass2");
          boolean _doubleArrow = Should.operator_doubleArrow(Boolean.valueOf(_login), Boolean.valueOf(false));
          Assert.assertTrue("\nExpected user.login(\"j.smith\", \"pass2\") => false but"
           + "\n     user.login(\"j.smith\", \"pass2\") is " + new StringDescription().appendValue(Boolean.valueOf(_login)).toString()
           + "\n     user is " + new StringDescription().appendValue(UserUserWithNameLoginAndPasswordThatSupportsAuthenticationSpec.this.user).toString() + "\n", _doubleArrow);
          
        }
      };
    ObjectExtensions.<String>operator_doubleArrow("User doesn\'t accept wrong password", _function);
  }
}
